unit sp_fs_FormDesign;
interface
// TSP_fs_FormDesign.
//   FastScript    Delphi-5.
//        
// Delphi-5      .  
//  FastScript  1.4.
//, .  SP_fs_FormDesign.doc
//--------------------------------------
//(c) Sergey Popov, Usinsk, Komi, 2005
//e-mail: sapopov@mail.ru
//http://sapopov.kominet.ru
// 1.01  01.03.2005
//Freeware

uses
  stdctrls,
  ExtCtrls, Buttons,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

//        
Const
  tc_Is_TPanel                = 1;
  tc_Is_TSplitter             = 2;
  tc_Is_TGroupBox             = 3;
  tc_Is_TCheckBox             = 4;
  tc_Is_TRadioButton          = 5;
  tc_Is_TButton               = 6;
  tc_Is_TSpeedButton          = 7;
  tc_Is_TLabel                = 8;
  tc_Is_TMemo                 = 9;
  tc_Is_TListBox              = 10;
  tc_Is_TEdit                 = 11;

type
  TSP_fs_FormDesign = class(TComponent) // 
  private
    { Private declarations }
    fVersion         : string;
    fFileName        : string;
    fCompName_IsNot_Save  : string;
    fCommment        : string;
    fOverwritePrompt : boolean;
    fGenerateSource_for_Event : boolean;
    fSource_for_Event_before_Var : boolean;


  protected
    { Protected declarations }

  public
    { Public declarations }

    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;


    function SaveToFile_FS : boolean;
    function Create_Source_for_Event_FS(Form99 : TForm; List : TStrings) : integer;
    function CreateScript_FormDesign_For_FS(Form99 : TForm; List : TStrings) : integer;
    function GetTypeControl_FS(Comp : TComponent) : integer;
    function GetTypeNameControl_FS(Comp : TComponent) : string;
    function GetNameProcEvent_FS(Comp : TComponent;NameProc : string) : string;


  published
    { Published declarations }

    property FileName : string read fFileName write fFileName;
    property ComponentsName_Not_Save : string read fCompName_IsNot_Save write fCompName_IsNot_Save;
    property Comment : string read fCommment write fCommment;
    property Version : string read fVersion;

    property OverwritePrompt : boolean read fOverwritePrompt write fOverwritePrompt default TRUE;

    property fsGenerateSource_for_Event : boolean read fGenerateSource_for_Event write fGenerateSource_for_Event default TRUE;
    property fsSource_for_Event_before_Var : boolean read fSource_for_Event_before_Var write fSource_for_Event_before_Var;

  end;

  
procedure Register;



//========================================================
//   
procedure AllTrim(var S:String);
function AllTrim99(Sx : string) : string;
function ReplaceSubStrInString(Sx,SFind,SReplace: String) : string;
function UPCaseCyrLatStr99(S : String) : string;
function saStrToInt(Sx:string; DefI : integer) : integer;
function saBooleanToStr(B : boolean;Nr : byte) : string;
function ItsNotReadOnlyDisk_1(Disk : string) : boolean;
function GetNewNameFile(NameFile : string) : string;
//========================================================


implementation

Const
  VersionX = '1.01 (01.03.2005)'; // 

  
constructor TSP_fs_FormDesign.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);

  fVersion:=VersionX;
  AllTrim(fFileName);
  if length(fFileName)<=0 then FileName:='C:\~SP_fs_FormDesign.pas';
  fOverwritePrompt:=TRUE;
  fGenerateSource_for_Event:=TRUE;
  AllTrim(fCommment);
  AllTrim(fCompName_IsNot_Save);
  if length(fCompName_IsNot_Save)>0 then begin
     fCompName_IsNot_Save:=ReplaceSubStrInString(fCompName_IsNot_Save,' ',',');
     fCompName_IsNot_Save:=UpCaseCyrLatStr99(fCompName_IsNot_Save);
  end;
end;


destructor TSP_fs_FormDesign.Destroy;
begin

  inherited Destroy;
end;


//====================================================
//====================================================
//====================================================
//,      
function FormStyleToStr_FS(V : TFormStyle) : string;
begin
  Result:='fsNormal';
  if V=fsNormal then Result:='fsNormal';
  if V=fsMDIChild then Result:='fsMDIChild';
  if V=fsMDIForm then Result:='fsMDIForm';
  if V=fsStayOnTop then Result:='fsStayOnTop';
end;


function BevelCutToStr_FS(V : TBevelCut) : string;
begin
  Result:='bvNone';
  if V=bvNone then Result:='bvNone';
  if V=bvLowered then Result:='bvLowered';
  if V=bvRaised then Result:='bvRaised';
  if V=bvSpace then Result:='bvSpace';
end;


function ScrollBarsToStr_FS(V : TScrollStyle) : string;
begin
  Result:='ssNone';
  if V=ssNone then Result:='ssNone';
  if V=ssHorizontal then Result:='ssHorizontal';
  if V=ssVertical then Result:='ssVertical';
  if V=ssBoth then Result:='ssBoth';
end;


function BorderStyleToStr_FS(V :  TBorderStyle) : string;
begin
  Result:='bsNone';
  if V=bsNone then Result:='bsNone';
  if V=bsSingle then Result:='bsSingle';
end;

function FormBorderStyleToStr_FS(V :  TFormBorderStyle) : string;
begin
  Result:='bsNone';
  if V=bsNone then Result:='bsNone';
  if V=bsSingle then Result:='bsSingle';
  if V=bsSizeable then Result:='bsSizeable';
  if V=bsDialog then Result:='bsDialog';
  if V=bsToolWindow then Result:='bsToolWindow';
  if V=bsSizeToolWin then Result:='bsSizeToolWin';
end;

function AlignToStr_FS(V : TAlign) : string;
begin
  Result:='alNone';
  if V=alNone then Result:='alNone';
  if V=alTop then Result:='alTop';
  if V=alBottom then Result:='alBottom';
  if V=alLeft then Result:='alLeft';
  if V=alRight then Result:='alRight';
  if V=alClient then Result:='alClient';
end;


function AlignmentToStr_FS(V : TAlignment) : string;
begin
  Result:='taLeftJustify';
  if V = taLeftJustify then Result:='taLeftJustify';
  if V = taCenter then Result:='taCenter';
  if V = taRightJustify then Result:='taRightJustify';
end;


function TextLayoutToStr_FS(V : TTextLayout) : string;
begin
  Result:='tlTop';
  if V = tlTop then Result:='tlTop';
  if V = tlCenter then Result:='tlCenter';
  if V = tlBottom then Result:='tlBottom';
end;

function PositionToStr_FS(V : TPosition) : string;
begin
  Result:='poDesigned';
  if V = poDesigned then Result:='poDesigned';
  if V = poDefault then Result:='poDefault';
  if V = poDefaultPosOnly then Result:='poDefaultPosOnly';
  if V = poDefaultSizeOnly then Result:='poDefaultSizeOnly';
  if V = poScreenCenter then Result:='poScreenCenter';
  if V = poDesktopCenter then Result:='poDesktopCenter';
  if V = poMainFormCenter then Result:='poMainFormCenter';
  if V = poOwnerFormCenter then Result:='poOwnerFormCenter';
end;

function FontStyleToStr_FS(V : TFontStyles) : string;
begin
  Result:='';
  if (fsBold in V) then Result:=Result+'fsBold';
  if (fsItalic in V) then Result:=Result+'+fsItalic';
  if (fsUnderline in V) then Result:=Result+'+fsUnderline';
  if (fsStrikeout in V) then Result:=Result+'+fsStrikeout';
  AllTrim(Result);
end;

function WindowStateToStr_FS(V : TWindowState) : string;
begin
  Result:='wsNormal';
  if V = wsNormal then Result:='wsNormal';
  if V = wsMinimized then Result:='wsMinimized';
  if V = wsMaximized then Result:='wsMaximized';
  AllTrim(Result);
end;

function CheckBoxStateToStr_FS(V : TCheckBoxState) : string;
begin
  Result:='cbUnchecked';
  if V = cbUnchecked then Result:='cbUnchecked';
  if V = cbChecked then Result:='cbChecked';
  if V = cbGrayed then Result:='cbGrayed';
  AllTrim(Result);
end;
//====================================================
//====================================================
//====================================================





function TSP_fs_FormDesign.GetTypeControl_FS(Comp : TComponent) : integer;
//""   
begin
  Result:=0;
  if (Comp is TPanel) then Result:=tc_is_TPanel;
  if (Comp is TGroupBox) then Result:=tc_is_TGroupBox;
  if (Comp is TButton) then Result:=tc_is_TButton;
  if (Comp is TSpeedButton) then Result:=tc_is_TSpeedButton;
  if (Comp is TLabel) then Result:=tc_is_TLabel;
  if (Comp is TEdit) then Result:=tc_is_TEdit;
  if (Comp is TListBox) then Result:=tc_is_TListBox;
  if (Comp is TMemo) then Result:=tc_is_TMemo;
  if (Comp is TSplitter) then Result:=tc_Is_TSplitter;
  if (Comp is TCheckBox) then Result:=tc_Is_TCheckBox;
  if (Comp is TRadioButton) then Result:=tc_Is_TRadioButton;
end;


function TSP_fs_FormDesign.GetTypeNameControl_FS(Comp : TComponent) : string;
//     
begin
  Result:='';
  if (Comp is TPanel) then Result:='TPanel';
  if (Comp is TGroupBox) then Result:='TGroupBox';
  if (Comp is TButton) then Result:='TButton';
  if (Comp is TSpeedButton) then Result:='TSpeedButton';
  if (Comp is TLabel) then Result:='TLabel';
  if (Comp is TEdit) then Result:='TEdit';
  if (Comp is TListBox) then Result:='TListBox';
  if (Comp is TMemo) then Result:='TMemo';
  if (Comp is TSplitter) then Result:='TSplitter';
  if (Comp is TCheckBox) then Result:='TCheckBox';
  if (Comp is TRadioButton) then Result:='TRadioButton';
end;

function TSP_fs_FormDesign.GetNameProcEvent_FS(Comp : TComponent;NameProc : string) : string;
//   ( )    
begin
  Result:='';
  AllTrim(NameProc);
  if length(NameProc)>0 then begin
     if GetTypeControl_FS(Comp)>0 then begin
        Result:='procedure '+Comp.Name+'_'+NameProc+'(Sender: '+GetTypeNameControl_FS(Comp)+');';
     end;
  end;
end;

function TSP_fs_FormDesign.Create_Source_for_Event_FS(Form99 : TForm; List : TStrings) : integer;
//      FastScript  
Var
  CountLine : integer;
  Yes333 : byte;
  TypeComp : integer;
  Tmp : TComponent;
  N123,Count,j,i : integer;
  SxCN : string;
  Sx : string;
begin
  Result:=0;
  if fGenerateSource_for_Event then begin
     AllTrim(fCompName_IsNot_Save);
     if length(fCompName_IsNot_Save)>0 then begin
        fCompName_IsNot_Save:=ReplaceSubStrInString(fCompName_IsNot_Save,' ',',');
        fCompName_IsNot_Save:=UpCaseCyrLatStr99(fCompName_IsNot_Save);
     end;
     if List<>NIL then begin
        CountLine := List.Count;
        SxCN:=fCompName_IsNot_Save;
        if length(SxCN)>0 then begin
           if SxCN[length(SxCN)]<>',' then SxCN:=SxCN+',';
        end;

        List.Add('//*************************************');
        List.ADD('//      ');
        for i := 0 to (Form99.ComponentCount - 1) do
         begin
          Tmp := Form99.Components[i];
          TypeComp:=GetTypeControl_FS(Tmp);
          if TypeComp>0 then begin
             if POS(UpCaseCyrLatStr99(Tmp.Name)+',',SxCN)<=0 then begin
                List.Add('');

                if (TypeComp=tc_is_TPanel) then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'DblClick'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnDblClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TGroupBox then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'DblClick'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnDblClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TButton then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TSpeedButton then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TLabel then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'DblClick'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnDblClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TEdit then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'DblClick'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnDblClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Enter'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnEnter');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Exit'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnExit');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TListBox then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'DblClick'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnDblClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Enter'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnEnter');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Exit'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnExit');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_is_TMemo then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'DblClick'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnDblClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Enter'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnEnter');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Exit'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnExit');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;

                if TypeComp=tc_Is_TRadioButton then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Enter'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnEnter');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Exit'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnExit');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;
                

                if TypeComp=tc_Is_TCheckBox then begin
                   List.Add('//......................................');
                   List.Add('//'+Tmp.Name);
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Click'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnClick');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'MouseMove'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnMouseMove');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Enter'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnEnter');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('');
                   Sx:=Alltrim99(GetNameProcEvent_FS(Tmp,'Exit'));
                   if length(Sx)>0 then begin
                      List.Add(Sx);
                      List.Add('//Event : OnExit');
                      List.Add('begin');
                      List.Add('');
                      List.Add('end;');
                   end;
                   List.Add('//......................................');
                end;
             end;
          end;
        end;

        List.Add('');
        List.Add('//*************************************');

        Result:=List.Count-CountLine;
        if Result<0 then Result:=0;
     end;
  end;
end;

function TSP_fs_FormDesign.CreateScript_FormDesign_For_FS(Form99 : TForm; List : TStrings) : integer;
//     (Form99)  FastScript  
Var
  Yes333 : byte;
  TypeComp : integer;
  Tmp : TComponent;
  iii,N123,Count,j,i : integer;
  SxCN : string;
  Sx : string;
begin
  Result:=0;
  AllTrim(fCompName_IsNot_Save);
  if length(fCompName_IsNot_Save)>0 then begin
     fCompName_IsNot_Save:=ReplaceSubStrInString(fCompName_IsNot_Save,' ',',');
     fCompName_IsNot_Save:=UpCaseCyrLatStr99(fCompName_IsNot_Save);
  end;
  if List<>NIL then begin
     List.Clear;
     if Form99<>NIL then begin
        AllTrim(fCommment);

        SxCN:=fCompName_IsNot_Save;
        if length(SxCN)>0 then begin
           if SxCN[length(SxCN)]<>',' then SxCN:=SxCN+',';
        end;
        List.ADD('#language PascalScript');
        List.ADD('//TSP_fs_FormDesign.CreateScript_FormDesign_For_FS');
        List.ADD('//About   : '+'    TSP_fs_FormDesign (Delphi-5)');
        List.ADD('//Version : '+fVersion+'  for FastScript-1.4 (Freeware)');
        List.ADD('//(c)     : '+'Sergey Popov, Usinsk, Komi, 2005');
        List.ADD('//e-mail  : '+'sapopov@mail.ru');
        List.ADD('//http    : '+'sapopov.kominet.ru');
        List.ADD('//Comment : '+fCommment);
        List.ADD('//Date    : '+DateTimeToStr(NOW));
        List.Add('//............................................');

        if fSource_for_Event_before_Var then begin
           List.Add('');
           List.Add('');
           Create_Source_for_Event_FS(Form99,List);
           List.Add('');
           List.Add('');
        end;

        List.Add('');
        List.Add('//............................................');
        List.Add('// ');
        N123:=List.Count-1;
        List.Add('Var');
        List.Add('  NrRes    : integer; // ,  ShowModal');
        List.Add('  FormMain : TForm; // ');
        Count:=0;
        for i := 0 to (Form99.ComponentCount - 1) do
         begin
          Tmp := Form99.Components[i];
          TypeComp:=GetTypeControl_FS(Tmp);
          if TypeComp>0 then begin
             if POS(UpCaseCyrLatStr99(Tmp.Name)+',',SxCN)<=0 then begin
               Count:=Count+1;
               Sx:='  '+Tmp.Name+' : ';
               Sx:=Sx+GetTypeNameControl_FS(Tmp);
               Sx:=Sx+';';
               List.Add(Sx);
             end;
          end;
        end;
        List.Add('//............................................');

        if not fSource_for_Event_before_Var then begin
           List.Add('');
           List.Add('');
           Create_Source_for_Event_FS(Form99,List);
           List.Add('');
           List.Add('');
        end;

        List.Add('');
        List.Add('//========================');
        List.Add('procedure Free_FormMain;');
        List.Add('//  ...');
        List.ADD('begin');
        List.ADD('  TRY');
        List.ADD('    if FormMain<>NIL then begin');
        List.ADD('       FormMain.Free;');
        List.ADD('       FormMain:=NIL;');
        List.ADD('    end;');
        List.ADD('  FINALLY');
        List.ADD('  END;');
        List.ADD('end; //Free_FormMain');
        List.Add('//========================');
        List.Add('');
        List.Add('');
        List.Add('//========================');
        List.Add('function Create_FormMain : TForm;');
        List.Add('//   .    ...');
        List.ADD('Var');
        List.ADD('  Yes : boolean;');
        List.ADD('begin');
        List.ADD('  Yes := FALSE;');
        List.ADD('  Result := TForm.Create(nil);');
        List.ADD('  ');
        List.ADD('  TRY');
        List.Add('    //------------------------');
        List.ADD('    // ');
        List.ADD('    Result.Caption     := '+#39+Form99.Caption+#39+';');
        List.ADD('    Result.Left        := '+IntTostr(Form99.Left)+';');
        List.ADD('    Result.Top         := '+IntTostr(Form99.Top)+';');
        List.ADD('    Result.Width       := '+IntTostr(Form99.Width)+';');
        List.ADD('    Result.Height      := '+IntTostr(Form99.Height)+';');
        List.ADD('    Result.FormStyle   := '+FormStyleToStr_FS(Form99.FormStyle)+';');
        List.ADD('    Result.Position    := '+PositionToStr_FS(Form99.Position)+';');
        List.ADD('    Result.BorderStyle := '+FormBorderStyleToStr_FS(Form99.BorderStyle)+';');
        List.ADD('    Result.BorderWidth := '+IntToStr(Form99.BorderWidth)+';');
        List.ADD('    Result.WindowState := '+WindowStateToStr_FS(Form99.WindowState)+';');
        List.ADD('    Result.Color       := '+ColorToString(Form99.Color)+';');
        List.ADD('    Result.Font.Name   := '+#39+Form99.Font.Name+#39+';');
        List.ADD('    Result.Font.Size   := '+IntToStr(Form99.Font.Size)+';');
        List.ADD('    Result.Font.Color  := '+ColorToString(Form99.Font.Color)+';');
        if length(FontStyleToStr_FS(Form99.Font.Style))>0 then begin
           List.ADD('    Result.Font.Style  := '+FontStyleToStr_FS(Form99.Font.Style)+';');
        end;
        List.ADD('    Result.Font.CharSet:= '+IntToStr(Form99.Font.CharSet)+';');
        List.Add('    //------------------------');


        for i := 0 to (Form99.ComponentCount - 1) do
         begin
          Tmp := Form99.Components[i];
          TypeComp:=GetTypeControl_FS(Tmp);
          if TypeComp>0 then begin
             if POS(UpCaseCyrLatStr99(Tmp.Name)+',',SxCN)<=0 then begin
               List.Add('    //......................................');
               List.Add('    //'+Tmp.Name);
               if TypeComp=tc_is_TPanel then begin
                  List.ADD('    '+Tmp.Name+' := TPanel.Create(Result);');
               end;
               if TypeComp=tc_is_TGroupBox then begin
                  List.ADD('    '+Tmp.Name+' := TGroupBox.Create(Result);');
               end;
               if TypeComp=tc_is_TButton then begin
                  List.ADD('    '+Tmp.Name+' := TButton.Create(Result);');
               end;
               if TypeComp=tc_is_TSpeedButton then begin
                  List.ADD('    '+Tmp.Name+' := TSpeedButton.Create(Result);');
               end;
               if TypeComp=tc_is_TLabel then begin
                  List.ADD('    '+Tmp.Name+' := TLabel.Create(Result);');
               end;
               if TypeComp=tc_is_TEdit then begin
                  List.ADD('    '+Tmp.Name+' := TEdit.Create(Result);');
               end;
               if TypeComp=tc_is_TListBox then begin
                  List.ADD('    '+Tmp.Name+' := TListBox.Create(Result);');
               end;
               if TypeComp=tc_Is_TSplitter then begin
                  List.ADD('    '+Tmp.Name+' := TSplitter.Create(Result);');
               end;
               if TypeComp=tc_Is_TRadioButton then begin
                  List.ADD('    '+Tmp.Name+' := TRadioButton.Create(Result);');
               end;
               if TypeComp=tc_Is_TCheckBox then begin
                  List.ADD('    '+Tmp.Name+' := TCheckBox.Create(Result);');
               end;
               if TypeComp=tc_is_TMemo then begin
                  List.ADD('    '+Tmp.Name+' := TMemo.Create(Result);');
               end;
               if UpCaseCyrLatStr99((Tmp as TControl).Parent.Name) = UpCaseCyrLatStr99(Form99.Name) then begin
                  List.ADD('    '+Tmp.Name+'.Parent := Result;');
               end
               else begin
                  List.ADD('    '+Tmp.Name+'.Parent := '+(Tmp as TControl).Parent.Name+';');
               end;

               if TypeComp=tc_Is_TSplitter then begin
                  //  TSplitter  FS-1.4
                  // Align     Left, Top  .. 
                  List.ADD('    '+Tmp.Name+'.Align := '+AlignToStr_FS((Tmp as TSplitter).Align)+';');
                  List.ADD('    '+Tmp.Name+'.Color := '+ColorToString((Tmp as TSplitter).Color)+';');
               end;

               List.ADD('    '+Tmp.Name+'.Left    := '+IntTostr((Tmp as TControl).Left)+';');
               List.ADD('    '+Tmp.Name+'.Top     := '+IntTostr((Tmp as TControl).Top)+';');
               List.ADD('    '+Tmp.Name+'.Width   := '+IntTostr((Tmp as TControl).Width)+';');
               List.ADD('    '+Tmp.Name+'.Height  := '+IntTostr((Tmp as TControl).Height)+';');
               List.ADD('    '+Tmp.Name+'.Visible := '+saBooleanToStr((Tmp as TControl).Visible,1)+';');
               List.ADD('    '+Tmp.Name+'.Tag     := '+IntToStr((Tmp as TControl).Tag)+';');

               Yes333 :=0;
               if TypeComp=tc_is_TPanel then Yes333:=1;
               if TypeComp=tc_is_TGroupBox then Yes333:=1;
               if TypeComp=tc_is_TButton then Yes333:=1;
               if TypeComp=tc_is_TLabel then Yes333:=1;
               if TypeComp=tc_is_TEdit then Yes333:=1;
               if TypeComp=tc_is_TListBox then Yes333:=1;
               if TypeComp=tc_Is_TRadioButton then Yes333:=1;
               if TypeComp=tc_Is_TCheckBox then Yes333:=1;
               if TypeComp=tc_is_TMemo then Yes333:=1;

               if Yes333>0 then begin
                  List.ADD('    '+Tmp.Name+'.Enabled  := '+saBooleanToStr((Tmp as TControl).Enabled,1)+';');
                  List.ADD('    '+Tmp.Name+'.Hint     := '+#39+(Tmp as TControl).Hint+#39+';');
                  List.ADD('    '+Tmp.Name+'.ShowHint := '+saBooleanToStr((Tmp as TControl).ShowHint,1)+';');
               end;

               if TypeComp=tc_is_TPanel then begin
                  List.Add('    '+Tmp.Name+'.Caption    := '+#39+(Tmp as TPanel).Caption+#39+';');
                  List.ADD('    '+Tmp.Name+'.Align      := '+AlignToStr_FS((Tmp as TPanel).Align)+';');
                  List.ADD('    '+Tmp.Name+'.Color      := '+ColorToString((Tmp as TPanel).Color)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TPanel).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TPanel).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TPanel).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TPanel).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TPanel).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Font.CharSet := '+IntToStr((Tmp as TPanel).Font.CharSet)+';');
                  List.ADD('    '+Tmp.Name+'.BevelWidth   := '+IntToStr((Tmp as TPanel).BevelWidth)+';');
                  List.ADD('    '+Tmp.Name+'.BorderWidth  := '+ IntToStr((Tmp as TPanel).BorderWidth) +';');
                  List.ADD('    '+Tmp.Name+'.BevelInner   := '+ BevelCutToStr_FS((Tmp as TPanel).BevelInner) +';');
                  List.ADD('    '+Tmp.Name+'.BevelOuter   := '+ BevelCutToStr_FS((Tmp as TPanel).BevelOuter) +';');
                  //List.ADD('    '+Tmp.Name+'.BorderStyle  := '+ BorderStyleToStr_FS((Tmp as TPanel).BorderStyle) +';');
                  List.ADD('    '+Tmp.Name+'.TabOrder     := '+ IntToStr((Tmp as TPanel).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop      := '+ saBooleanToStr((Tmp as TPanel).TabStop,1) +';');
                  List.ADD('    '+Tmp.Name+'.AutoSize     := '+ saBooleanToStr((Tmp as TPanel).AutoSize,1) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnDblClick  := @'+Tmp.Name+'_DblClick'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                  end;
               end;

               if TypeComp=tc_is_TGroupBox then begin
                  List.Add('    '+Tmp.Name+'.Caption    := '+#39+(Tmp as TGroupBox).Caption+#39+';');
                  List.ADD('    '+Tmp.Name+'.Align      := '+AlignToStr_FS((Tmp as TGroupBox).Align)+';');
                  List.ADD('    '+Tmp.Name+'.Color      := '+ColorToString((Tmp as TGroupBox).Color)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TGroupBox).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TGroupBox).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TGroupBox).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TGroupBox).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TGroupBox).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Font.CharSet := '+IntToStr((Tmp as TGroupBox).Font.CharSet)+';');
                  List.ADD('    '+Tmp.Name+'.TabOrder     := '+ IntToStr((Tmp as TGroupBox).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop      := '+ saBooleanToStr((Tmp as TGroupBox).TabStop,1) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnDblClick  := @'+Tmp.Name+'_DblClick'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                  end;
               end;

               if TypeComp=tc_is_TButton then begin
                  List.Add('    '+Tmp.Name+'.Caption    := '+#39+(Tmp as TButton).Caption+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TButton).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TButton).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TButton).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TButton).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TButton).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Font.CharSet := '+IntToStr((Tmp as TButton).Font.CharSet)+';');
                  List.ADD('    '+Tmp.Name+'.TabOrder     := '+ IntToStr((Tmp as TButton).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop      := '+ saBooleanToStr((Tmp as TButton).TabStop,1) +';');
                  List.Add('    '+Tmp.Name+'.Cancel       := '+saBooleanToStr((Tmp as TButton).Cancel,1) +';');
                  List.Add('    '+Tmp.Name+'.ModalResult  := '+IntToStr((Tmp as TButton).ModalResult) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                  end;
               end;

               if TypeComp=tc_is_TSpeedButton then begin
                  List.Add('    '+Tmp.Name+'.Caption    := '+#39+(Tmp as TSpeedButton).Caption+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TSpeedButton).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TSpeedButton).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TSpeedButton).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TSpeedButton).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TSpeedButton).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Font.CharSet := '+IntToStr((Tmp as TSpeedButton).Font.CharSet)+';');
                  List.ADD('    '+Tmp.Name+'.GroupIndex   := '+IntToStr((Tmp as TSpeedButton).GroupIndex)+';');
                  List.ADD('    '+Tmp.Name+'.Margin       := '+IntToStr((Tmp as TSpeedButton).Margin)+';');
                  List.ADD('    '+Tmp.Name+'.NumGlyphs    := '+IntToStr((Tmp as TSpeedButton).NumGlyphs)+';');
                  List.ADD('    '+Tmp.Name+'.Spacing      := '+IntToStr((Tmp as TSpeedButton).Spacing)+';');
                  List.Add('    '+Tmp.Name+'.Transparent  := '+saBooleanToStr((Tmp as TSpeedButton).Transparent,1) +';');
                  List.Add('    '+Tmp.Name+'.AllowAllUp   := '+saBooleanToStr((Tmp as TSpeedButton).AllowAllUp,1) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                  end;
               end;

               if TypeComp=tc_is_TLabel then begin
                  List.Add('    '+Tmp.Name+'.Caption     := '+#39+(Tmp as TLabel).Caption+#39+';');
                  List.Add('    '+Tmp.Name+'.Transparent := '+saBooleanToStr((Tmp as TLabel).Transparent,1) +';');
                  List.Add('    '+Tmp.Name+'.WordWrap    := '+saBooleanToStr((Tmp as TLabel).WordWrap,1) +';');
                  List.Add('    '+Tmp.Name+'.Alignment   := '+AlignmentToStr_FS((Tmp as TLabel).Alignment) +';');
                  List.Add('    '+Tmp.Name+'.Layout      := '+TextLayoutToStr_FS((Tmp as TLabel).Layout) +';');
                  List.Add('    '+Tmp.Name+'.AutoSize    := '+saBooleanToStr((Tmp as TLabel).AutoSize,1) +';');
                  List.ADD('    '+Tmp.Name+'.Align       := '+AlignToStr_FS((Tmp as TLabel).Align)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name   := '+#39+(Tmp as TLabel).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size   := '+IntToStr((Tmp as TLabel).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color  := '+ColorToString((Tmp as TLabel).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TLabel).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TLabel).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Color       := '+ColorToString((Tmp as TLabel).Color)+';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnDblClick  := @'+Tmp.Name+'_DblClick'+';');
                  end;
               end;

               if TypeComp=tc_is_TEdit then begin
                  List.Add('    '+Tmp.Name+'.Text       := '+#39+(Tmp as TEdit).Text+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TEdit).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TEdit).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TEdit).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TEdit).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TEdit).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Color        := '+ColorToString((Tmp as TEdit).Color)+';');
                  List.ADD('    '+Tmp.Name+'.TabOrder     := '+ IntToStr((Tmp as TEdit).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop      := '+ saBooleanToStr((Tmp as TEdit).TabStop,1) +';');
                  List.ADD('    '+Tmp.Name+'.ReadOnly     := '+ saBooleanToStr((Tmp as TEdit).ReadOnly,1) +';');
                  List.ADD('    '+Tmp.Name+'.MaxLength    := '+ IntToStr((Tmp as TEdit).MaxLength) +';');
                  List.ADD('    '+Tmp.Name+'.AutoSize     := '+ saBooleanToStr((Tmp as TEdit).AutoSize,1) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnDblClick  := @'+Tmp.Name+'_DblClick'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                     List.ADD('    '+Tmp.Name+'.OnEnter     := @'+Tmp.Name+'_Enter'+';');
                     List.ADD('    '+Tmp.Name+'.OnExit      := @'+Tmp.Name+'_Exit'+';');
                  end;
               end;

               if TypeComp=tc_is_TListBox then begin
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TListBox).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TListBox).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TListBox).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TListBox).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TListBox).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Color          := '+ColorToString((Tmp as TListBox).Color)+';');
                  List.ADD('    '+Tmp.Name+'.TabOrder       := '+ IntToStr((Tmp as TListBox).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop        := '+ saBooleanToStr((Tmp as TListBox).TabStop,1) +';');
                  List.ADD('    '+Tmp.Name+'.Align          := '+AlignToStr_FS((Tmp as TListBox).Align)+';');
                  List.ADD('    '+Tmp.Name+'.Columns        := '+ IntToStr((Tmp as TListBox).Columns) +';');
                  List.ADD('    '+Tmp.Name+'.ExtendedSelect := '+ saBooleanToStr((Tmp as TListBox).ExtendedSelect,1) +';');
                  List.ADD('    '+Tmp.Name+'.MultiSelect    := '+ saBooleanToStr((Tmp as TListBox).MultiSelect,1) +';');
                  List.ADD('    '+Tmp.Name+'.Sorted         := '+ saBooleanToStr((Tmp as TListBox).Sorted,1) +';');
                  List.ADD('    '+Tmp.Name+'.ItemHeight     := '+ IntToStr((Tmp as TListBox).ItemHeight) +';');
                  List.ADD('    '+Tmp.Name+'.TabWidth       := '+ IntToStr((Tmp as TListBox).TabWidth) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnDblClick  := @'+Tmp.Name+'_DblClick'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                     List.ADD('    '+Tmp.Name+'.OnEnter     := @'+Tmp.Name+'_Enter'+';');
                     List.ADD('    '+Tmp.Name+'.OnExit      := @'+Tmp.Name+'_Exit'+';');
                  end;
                  if (Tmp as TListBox).Items.Count>0 then begin
                     for iii:=0 to ((Tmp as TListBox).Items.Count-1) do
                      begin
                        List.ADD('    '+Tmp.Name+'.Items.ADD('+#39+(Tmp as TListBox).Items[iii]+#39+');');
                     end;
                  end;
               end;

               if TypeComp=tc_is_TMemo then begin
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TMemo).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TMemo).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TMemo).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TMemo).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TMemo).Font.Style)+';');
                  end;
                  List.ADD('    '+Tmp.Name+'.Color         := '+ColorToString((Tmp as TMemo).Color)+';');
                  List.ADD('    '+Tmp.Name+'.TabOrder      := '+ IntToStr((Tmp as TMemo).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop       := '+ saBooleanToStr((Tmp as TMemo).TabStop,1) +';');
                  List.ADD('    '+Tmp.Name+'.Align         := '+AlignToStr_FS((Tmp as TMemo).Align)+';');
                  List.Add('    '+Tmp.Name+'.WordWrap      := '+saBooleanToStr((Tmp as TMemo).WordWrap,1) +';');
                  List.Add('    '+Tmp.Name+'.Alignment     := '+AlignmentToStr_FS((Tmp as TMemo).Alignment) +';');
                  List.Add('    '+Tmp.Name+'.WantTabs      := '+saBooleanToStr((Tmp as TMemo).WantTabs,1) +';');
                  List.Add('    '+Tmp.Name+'.WantReturns   := '+saBooleanToStr((Tmp as TMemo).WantReturns,1) +';');
                  List.Add('    '+Tmp.Name+'.HideSelection := '+saBooleanToStr((Tmp as TMemo).HideSelection,1) +';');
                  List.ADD('    '+Tmp.Name+'.MaxLength     := '+ IntToStr((Tmp as TMemo).MaxLength) +';');
                  List.Add('    '+Tmp.Name+'.OEMConvert    := '+saBooleanToStr((Tmp as TMemo).OEMConvert,1) +';');
                  List.Add('    '+Tmp.Name+'.ReadOnly      := '+saBooleanToStr((Tmp as TMemo).ReadOnly,1) +';');
                  List.Add('    '+Tmp.Name+'.ScrollBars    := '+ScrollBarsToStr_FS((Tmp as TMemo).ScrollBars) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnDblClick  := @'+Tmp.Name+'_DblClick'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                     List.ADD('    '+Tmp.Name+'.OnEnter     := @'+Tmp.Name+'_Enter'+';');
                     List.ADD('    '+Tmp.Name+'.OnExit      := @'+Tmp.Name+'_Exit'+';');
                  end;
                  if (Tmp as TMemo).Lines.Count>0 then begin
                     for iii:=0 to ((Tmp as TMemo).Lines.Count-1) do
                      begin
                        List.ADD('    '+Tmp.Name+'.Lines.ADD('+#39+(Tmp as TMemo).Lines[iii]+#39+');');
                     end;
                  end;
               end;

               if TypeComp=tc_Is_TSplitter then begin
                  //List.ADD('    '+Tmp.Name+'.Color := '+ColorToString((Tmp as TSplitter).Color)+';');
                  //List.ADD('    '+Tmp.Name+'.Align := '+AlignToStr_FS((Tmp as TSplitter).Align)+';');
               end;


               if TypeComp=tc_Is_TRadioButton then begin
                  List.Add('    '+Tmp.Name+'.Caption    := '+#39+(Tmp as TRadioButton).Caption+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TRadioButton).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TRadioButton).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TRadioButton).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TRadioButton).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TRadioButton).Font.Style)+';');
                  end;
                  //List.Add('    '+Tmp.Name+'.Alignment   := '+AlignmentToStr_FS((Tmp as TRadioButton).Alignment) +';');
                  List.ADD('    '+Tmp.Name+'.Color       := '+ColorToString((Tmp as TRadioButton).Color)+';');
                  List.ADD('    '+Tmp.Name+'.Checked     := '+ saBooleanToStr((Tmp as TRadioButton).Checked,1) +';');
                  List.ADD('    '+Tmp.Name+'.TabOrder    := '+ IntToStr((Tmp as TRadioButton).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop     := '+ saBooleanToStr((Tmp as TRadioButton).TabStop,1) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                     List.ADD('    '+Tmp.Name+'.OnEnter     := @'+Tmp.Name+'_Enter'+';');
                     List.ADD('    '+Tmp.Name+'.OnExit      := @'+Tmp.Name+'_Exit'+';');
                  end;
               end;

               if TypeComp=tc_Is_TCheckBox then begin
                  List.Add('    '+Tmp.Name+'.Caption    := '+#39+(Tmp as TCheckBox).Caption+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Name  := '+#39+(Tmp as TCheckBox).Font.Name+#39+';');
                  List.ADD('    '+Tmp.Name+'.Font.Size  := '+IntToStr((Tmp as TCheckBox).Font.Size)+';');
                  List.ADD('    '+Tmp.Name+'.Font.Color := '+ColorToString((Tmp as TCheckBox).Font.Color)+';');
                  if length(FontStyleToStr_FS((Tmp as TCheckBox).Font.Style))>0 then begin
                     List.ADD('    '+Tmp.Name+'.Font.Style := '+FontStyleToStr_FS((Tmp as TCheckBox).Font.Style)+';');
                  end;
                  //List.Add('    '+Tmp.Name+'.Alignment   := '+AlignmentToStr_FS((Tmp as TCheckBox).Alignment) +';');
                  List.ADD('    '+Tmp.Name+'.Color       := '+ColorToString((Tmp as TCheckBox).Color)+';');
                  List.ADD('    '+Tmp.Name+'.TabOrder    := '+ IntToStr((Tmp as TCheckBox).TabOrder) +';');
                  List.ADD('    '+Tmp.Name+'.TabStop     := '+ saBooleanToStr((Tmp as TCheckBox).TabStop,1) +';');
                  List.ADD('    '+Tmp.Name+'.Checked     := '+ saBooleanToStr((Tmp as TCheckBox).Checked,1) +';');
                  List.ADD('    '+Tmp.Name+'.AllowGrayed := '+ saBooleanToStr((Tmp as TCheckBox).AllowGrayed,1) +';');
                  List.Add('    '+Tmp.Name+'.State       := '+CheckBoxStateToStr_FS((Tmp as TCheckBox).State) +';');
                  if fGenerateSource_for_Event then begin
                     List.ADD('    '+Tmp.Name+'.OnClick     := @'+Tmp.Name+'_Click'+';');
                     List.ADD('    '+Tmp.Name+'.OnMouseMove := @'+Tmp.Name+'_MouseMove'+';');
                     List.ADD('    '+Tmp.Name+'.OnEnter     := @'+Tmp.Name+'_Enter'+';');
                     List.ADD('    '+Tmp.Name+'.OnExit      := @'+Tmp.Name+'_Exit'+';');
                  end;
               end;
               List.Add('    //......................................');
             end;
          end;
        end;

        List.ADD('');
        List.ADD('');
        List.ADD('    Yes := TRUE;');
        List.ADD('  FINALLY');
        List.ADD('    if not Yes then begin');
        List.ADD('       // ,   ...');
        List.ADD('       if Result<>NIL then begin');
        List.ADD('          Result.Free;');
        List.ADD('          Result:=NIL;');
        List.ADD('       end;');
        List.ADD('    end;');
        List.ADD('  END;');
        List.ADD('');
        List.ADD('end; //Create_FormMain');
        List.Add('//========================');
        List.ADD('');
        List.Add('//========================');
        List.Add('function FormMain_Execute : integer;');
        List.Add('//,    ');
        List.Add('begin');
        List.Add('  Result:=-1;');
        List.Add('  FormMain:=Create_FormMain;');
        List.Add('  TRY');
        List.Add('    //...');
        List.Add('    // .     ,  ');
        List.Add('    //...');
        List.Add('    Result:=FormMain.ShowModal;');
        List.Add('  FINALLY');
        List.Add('    Free_FormMain;');
        List.Add('  END;');
        List.Add('end; //FormMain_Execute');
        List.Add('//========================');
        List.ADD('');
        List.ADD('');
        List.ADD('//==================');
        List.ADD('BEGIN');
        List.ADD('  NrRes := FormMain_Execute; //    ');
        List.ADD('  //if NrRes = 1 then begin //Ok');
        List.ADD('  //end;');
        List.ADD('  //if NrRes = 2 then begin //Cancel');
        List.ADD('  //end;');
        List.ADD('END.');
        List.ADD('');
     end;
     Result:=List.Count;

  end;
end;

function TSP_fs_FormDesign.SaveToFile_FS : boolean;
Var
  Sx : string;
  Yes : byte;
  List : TStrings;
begin
  Result:=FALSE;
  Yes:=0;
  if (Owner IS TForm) then begin
     AllTrim(fFileName);
     if length(fFileName)>0 then begin
        Yes:=1;
        Sx:=ExtractFilePath(fFileName);
        if length(Sx)>0 then begin
           if not ItsNotReadOnlyDisk_1(Sx) then begin
              Yes:=0;
           end;
        end;
     end;
  end;
  if Yes>0 then begin
     if FileExists(fFileName) then begin
        if fOverwritePrompt then begin
           Yes:=0;
           if MessageDlg(' '+fFileName+'  .  ?',mtConfirmation,mbOkCancel,0) = mrOk then begin
              Yes:=1;
           end;
        end;
     end;
  end;
  if Yes>0 then begin
     List:=TStringList.Create;
     TRY
       CreateScript_FormDesign_For_FS((Owner AS TForm),List);
       if List.Count>0 then begin
          List.SaveToFile(fFileName);
          Result:=TRUE;
       end;
     FINALLY
       if List<>NIL then begin
          List.Clear;
          List.Free;
          List:=NIL;
       end;
     END;

  end;
end;









//========================================================
//   
//========================================================

procedure rtrim(var S:String);
{   S  }
var
  m,i : integer;
begin
  i:=0;
  while i=0 do
    begin
      m:=length(s);
      if m>0 then begin
         if s[m]<>' ' then i:=1;
         if s[m]=' ' then delete(s,m,1);
      end;
      if m<=0 then i:=1;
  end;
end;

procedure ltrim(var S:String);
{   S  }
var
  m,i : integer;
begin
  i:=0;
  while i=0 do
    begin
      m:=length(s);
      if m>0 then begin
         if s[1]<>' ' then i:=1;
         if s[1]=' ' then delete(s,1,1);
      end;
      if m<=0 then i:=1;
  end;
end;

procedure AllTrim(var S:String);
{   S    }
begin
  rtrim(S);
  ltrim(S);
end;

function AllTrim99(Sx : string) : string;
begin
  Result:=Sx;
  AllTrim(Result);
end;

function ReplaceSubStrInString(Sx,SFind,SReplace: String) : string;
{  Sx  SFind  SReplace}
Var
  N : integer;
  Exit99 : byte;
begin
  Result:=Sx;
  if SFind<>SReplace then begin
     if (Length(Sx)>0) and (Length(SFind)>0) then begin
        Exit99:=0;
        while Exit99<=0 do
         begin
           N:=POS(SFind,Result);
           if N<=0 then begin
              Exit99:=1;
           end
           else begin
              System.Delete(Result,N,Length(SFind));
              System.Insert(SReplace,Result,N);
           end;
        end;
     end;
  end;
end;

procedure UpCaseCyrLatChar(Var Ch:Char);
{  Ch(  ) ->  }
begin
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';
  if Ch='' then Ch:='';

  if Ch='q' then Ch:='Q';
  if Ch='w' then Ch:='W';
  if Ch='e' then Ch:='E';
  if Ch='r' then Ch:='R';
  if Ch='t' then Ch:='T';
  if Ch='y' then Ch:='Y';
  if Ch='u' then Ch:='U';
  if Ch='i' then Ch:='I';
  if Ch='o' then Ch:='O';
  if Ch='p' then Ch:='P';
  if Ch='a' then Ch:='A';
  if Ch='s' then Ch:='S';
  if Ch='d' then Ch:='D';
  if Ch='f' then Ch:='F';
  if Ch='g' then Ch:='G';
  if Ch='h' then Ch:='H';
  if Ch='j' then Ch:='J';
  if Ch='k' then Ch:='K';
  if Ch='l' then Ch:='L';
  if Ch='z' then Ch:='Z';
  if Ch='x' then Ch:='X';
  if Ch='c' then Ch:='C';
  if Ch='v' then Ch:='V';
  if Ch='b' then Ch:='B';
  if Ch='n' then Ch:='N';
  if Ch='m' then Ch:='M';
end;

procedure UPCaseCyrLatStr(Var S : String);
{         S ->  }
Var
  i,m : integer;
begin
  m:=Length(S);
  if m>0 then begin
     for i:=1 to m do
       begin
         UpCaseCyrLatChar(S[i]);
     end;
  end;
end;


function UPCaseCyrLatStr99(S : String) : string;
begin
  Result:=S;
  UPCaseCyrLatStr(Result);
end;

function saBooleanToStr(B : boolean;Nr : byte) : string;
begin
  Result:='0';
  if Nr<=0 then  Result:='0';
  if Nr=1 then  Result:='FALSE';
  if Nr=2 then  Result:='NOT';
  if Nr=3 then  Result:='NO';
  if Nr>=4 then  Result:='';
  if B then begin
     if Nr<=0 then  Result:='1';
     if Nr=1 then  Result:='TRUE';
     if Nr=2 then  Result:='YES';
     if Nr=3 then  Result:='YES';
     if Nr>=4 then  Result:='';
  end;
end;

function saStrToInt(Sx:string; DefI : integer) : integer;
Var
  Res : integer;
begin
  AllTrim(Sx);
  Val(Sx,Result,Res);
  if Res<>0 then Result:=DefI;
end;

function GetNewNameFile(NameFile : string) : string;
{  }
Var
  Sx,Path,NameF, Ext : String;
  i : LongInt;
begin
  Result:=NameFile;

  Path:=ExtractFilePath(NameFile);
  NameF:=ExtractFileName(NameFile);
  NameF:=ChangeFileExt(NameF,'');
  Ext:=ExtractFileExt(NameFile);

  Sx:=NameFile;
  i:=0;
  while i<999999 do
   begin
     i:=i+1;

     if FileExists(Sx) then begin
        Str(i,Sx);
        Sx:=Path+NameF+'-'+Sx+Ext;
     end
     else begin
        Result:=Sx;
        i:=999999+1;
     end;

  end;
end;

function ItsNotReadOnlyDisk_1(Disk : string) : boolean;
{     }
Var
  NameF : string;
  Ok99 : boolean;
  o : textfile;
begin
  Result:=FALSE;

  AllTrim(Disk);
  if Length(Disk)>0 then begin
     TRY
       NameF :=GetNewNameFile(Disk[1]+':\~!789.~~~');
       AssignFile(o,NameF);
       {$I-} rewrite(o) {$I+};
       Ok99:=(IoResult=0);
       if Ok99 then begin
          Result:=TRUE;
       end;
     FINALLY
       {$I-} CloseFile(o) {$I+};
       Ok99:=(IoResult=0);
       DeleteFile(NameF);
     END;
  end;
end;
//========================================================
//========================================================


//==============================================================
procedure Register;
begin
  RegisterComponents('SP', [TSP_fs_FormDesign]);
end;


end.



